class C {
    C(int j) {
	super();
	f = j;
    }
    int f;
    C foo;

    static public void main(String[] args) {
	int i = 9;
	C a = new C(i);
	C b = new C(i);
	a.foo = a;
	b.foo = null;
	if (false) { b.foo = a; }

	int y = a.foo.f; // a.foo can not be null (analysis not precise enough to discover this)
	int z = b.foo.f; // b.foo may be null
    }

}
